//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
 ylow=0;
 yhigh=1;
 usbasp_open();
// Chart1->BottomAxis->Automatic  =  false;
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
 usbasp_close();
}
//----------------------------------------------------------------------------
void __fastcall TForm1::Exit_ButtonClick(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Start_ButtonClick(TObject *Sender)
{
//Is AVR Busy ???
unsigned char send[4];
unsigned char buffer[244];
unsigned char i,outdata;
unsigned int  temp;
float z;

AnsiString s,s1;   //for time display label

buffer[0]=0xff;

// Read one byte via USB
usbasp_transmit(USB_ENDPOINT_IN,getstata,send,buffer,1);

if(buffer[0]==0)           // AVR report not busy, get input capture counts
 {

   usbasp_transmit(USB_ENDPOINT_IN,getcount,send,buffer,1); // Ask AVR how many bytes

   count=buffer[0];        // AVR should report number of words=(bytes/2) back
   if(count>0)             // Read captured data, allows next capture, then process data
    {
     //Read from AVR all captured data into buffer[]
     usbasp_transmit(USB_ENDPOINT_IN,getirdata,send,buffer,count*2);

     //enable AVR to do next capture
     usbasp_transmit(USB_ENDPOINT_OUT,next_run,send,&outdata,0);  //Why 0 and not 1 ??

     //Process captured data, form them into a 16-bit integer
     for(i=0;i<count;i++)
      {
        temp=(unsigned int)(buffer[2*i]);       //Higher 8 bits
        temp=temp<<8;
        temp=temp+(unsigned int)(buffer[2*i+1]);//Lower 8 bits
        igirdata[i]=temp;                        // store to array iirdata[]
      }

        Series1->Clear();
        Series1->AddXY(-1.0,1,"idle",clRed);
        Series1->AddXY(0.0,1," ",clRed);
        DisplayW();
      }
 }
}

//------------------------------------------------------------------

void TForm1::DisplayW(void)
{
 unsigned char i;
 float z;
        AnsiString s,s1;   //for time display label

        Series1->Clear();
        Series1->AddXY(-1.0,yhigh,"idle",clRed);
        Series1->AddXY(0.0,yhigh," ",clRed);

        for(i=0;i<count;i++)
         {
           if (i>0)
           {
             s1=" ("+RightStr("  "+FloatToStrF((igirdata[i]-igirdata[i-1])*5.33333,ffFixed,4,0)+")",5);
           }

           z=igirdata[i]*0.0053333;

           s=FloatToStrF(z,ffFixed,7,1);
           s=s+s1;
           if(i%2==0)
           {
            Series1->AddXY(z-0.0001,yhigh,s,clRed);
            Series1->AddXY(z,ylow,' ',clRed);
           }
           else
            {
             Series1->AddXY(z-0.0001,ylow,s,clRed);
             Series1->AddXY(z,yhigh,' ',clRed);
            }
         }

        Chart1->BottomAxis->Automatic=false;
        Chart1->BottomAxis->Minimum=Series1->XValues->First();
        Chart1->BottomAxis->Maximum=Series1->XValues->Last();
}


//--------------------------------------------------------------------------
void __fastcall TForm1::VModeClick(TObject *Sender)
{
        if (yhigh==1)
        { ylow=1;
          yhigh=0;
          Series1->SeriesColor = clRed;
          Chart1->LeftAxis->Title->Caption= "IR Carrier On/Off";
          VMode->Caption = "View as Pin Voltage";

        }
        else
        { ylow=0;
          yhigh=1;
          Series1->SeriesColor = clBlue;
          Chart1->LeftAxis->Title->Caption= "Pin Voltage High/Low";
          VMode->Caption = "View as IR Carrier";
        }

     DisplayW();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ViewAll_BitBtnClick(TObject *Sender)
{
 Chart1->BottomAxis->Automatic=false;
 Chart1->LeftAxis->Maximum=1.2;
 Chart1->LeftAxis->Minimum=-0.1;
 Chart1->BottomAxis->Minimum=Series1->XValues->First();
 Chart1->BottomAxis->Maximum=Series1->XValues->Last();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ZoomMore_BitBtnClick(TObject *Sender)
{
 Chart1->BottomAxis->Automatic=false;
 Chart1->LeftAxis->Maximum=1.2;
 Chart1->LeftAxis->Minimum=-0.1;
 if((Chart1->BottomAxis->Maximum-Chart1->BottomAxis->Minimum)>15.0)
  {
   if(Chart1->BottomAxis->Maximum>15.0)
     Chart1->BottomAxis->Maximum=Chart1->BottomAxis->Maximum-15.0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ZoomLess_BitBtnClick(TObject *Sender)
{
 Chart1->BottomAxis->Automatic=false;
 Chart1->LeftAxis->Maximum=1.2;
 Chart1->LeftAxis->Minimum=-0.1;
 if((Series1->XValues->Last()-Chart1->BottomAxis->Maximum)>15.0)
  {
   Chart1->BottomAxis->Maximum=Chart1->BottomAxis->Maximum+15.0;
  }
 else
  Chart1->BottomAxis->Maximum=Series1->XValues->Last();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MoveLeft_BitBtnClick(TObject *Sender)
{
 Chart1->BottomAxis->Automatic=false;
 Chart1->LeftAxis->Maximum=1.2;
 Chart1->LeftAxis->Minimum=-0.1;
 if((Chart1->BottomAxis->Minimum - Series1->XValues->First())>=5.0)
  {
    Chart1->BottomAxis->Minimum=Chart1->BottomAxis->Minimum-5.0;
    Chart1->BottomAxis->Maximum=Chart1->BottomAxis->Maximum-5.0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MoveRight_BitBtnClick(TObject *Sender)
{
 Chart1->BottomAxis->Automatic=false;
 Chart1->LeftAxis->Maximum=1.2;
 Chart1->LeftAxis->Minimum=-0.1;
 if((Series1->XValues->Last() - Chart1->BottomAxis->Maximum)>=5.0)
  {
    Chart1->BottomAxis->Maximum=Chart1->BottomAxis->Maximum+5.0;
    Chart1->BottomAxis->Minimum=Chart1->BottomAxis->Minimum+5.0;
  }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

