//---------------------------------------------------------------------------


#pragma hdrstop

#include <vcl.h>
#include "Unit2.h"
#include "Unit1.h"
#include "usb.h"

//---------------------------------------------------------------------------
int usbasp_open()
{
  struct usb_bus    *bus;
  struct usb_device *dev = 0;
  usb_init();
  usb_find_busses();
  usb_find_devices();
  for(bus=usb_get_busses(); bus; bus=bus->next)
   {
    for(dev=bus->devices; dev; dev=dev->next)
     {
      if((dev->descriptor.idVendor == USBDEV_VENDOR) && (dev->descriptor.idProduct == USBDEV_PRODUCT))
	break;
     }
    if(dev)
      break;
   }
  if(!dev){
    ShowMessage("AVRUSB_IR not found");
    usbhandle=NULL;
    return 1;
  }
  usbhandle = usb_open(dev);
  if(!usbhandle){
    ShowMessage("Open AVRUSB_IR Failed");
    usbhandle=NULL;
    return 2;
  }
  return 0;
}
/////////////////////////////////////////////////////////////////
void usbasp_close()
{
  if(!usbhandle)
   return;
  usb_close(usbhandle);
}
/////////////////////////////////////////////////////////////////////
int usbasp_transmit(unsigned char dir, unsigned char functionid,
			   unsigned char send[4], unsigned char * buffer, int buffersize)
{
  int nbytes;
  if(usbhandle)
   nbytes = usb_control_msg(usbhandle,
			   USB_TYPE_VENDOR | USB_RECIP_DEVICE | dir ,
			   functionid,
			   (send[1] << 8) | send[0],
			   (send[3] << 8) | send[2],
			   buffer, buffersize,
			   5000);  //5000 is timeout value
  if(nbytes < 0)
   {
    ShowMessage("Transmit Error. Closing AVRUSB");
    usbasp_close();
   }
  return nbytes;
}
#pragma package(smart_init)
 